/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.ext.web.api.contract.openapi3;

import io.vertx.reactivex.RxHelper;
import io.vertx.reactivex.ObservableHelper;
import io.vertx.reactivex.FlowableHelper;
import io.vertx.reactivex.impl.AsyncResultMaybe;
import io.vertx.reactivex.impl.AsyncResultSingle;
import io.vertx.reactivex.impl.AsyncResultCompletable;
import io.vertx.reactivex.WriteStreamObserver;
import io.vertx.reactivex.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler.class)
public class OpenAPI3RequestValidationHandler implements io.vertx.reactivex.ext.web.api.contract.HTTPOperationRequestValidationHandler, Handler<io.vertx.reactivex.ext.web.RoutingContext> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    OpenAPI3RequestValidationHandler that = (OpenAPI3RequestValidationHandler) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<OpenAPI3RequestValidationHandler> __TYPE_ARG = new TypeArg<>(    obj -> new OpenAPI3RequestValidationHandler((io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler) obj),
    OpenAPI3RequestValidationHandler::getDelegate
  );

  private final io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler delegate;
  
  public OpenAPI3RequestValidationHandler(io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler delegate) {
    this.delegate = delegate;
  }

  public OpenAPI3RequestValidationHandler(Object delegate) {
    this.delegate = (io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler)delegate;
  }

  public io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler getDelegate() {
    return delegate;
  }

  /**
   * Something has happened, so handle it.
   * @param event the event to handle
   */
  @Deprecated()
  public void handle(io.vertx.reactivex.ext.web.RoutingContext event) { 
    delegate.handle(event.getDelegate());
  }

  /**
   * Function that parse the operation specification and generate validation rules
   */
  @Deprecated()
  public void parseOperationSpec() { 
    delegate.parseOperationSpec();
  }

  public static OpenAPI3RequestValidationHandler newInstance(io.vertx.ext.web.api.contract.openapi3.OpenAPI3RequestValidationHandler arg) {
    return arg != null ? new OpenAPI3RequestValidationHandler(arg) : null;
  }

}
