/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.sqlclient;

import io.vertx.reactivex.RxHelper;
import io.vertx.reactivex.ObservableHelper;
import io.vertx.reactivex.FlowableHelper;
import io.vertx.reactivex.impl.AsyncResultMaybe;
import io.vertx.reactivex.impl.AsyncResultSingle;
import io.vertx.reactivex.impl.AsyncResultCompletable;
import io.vertx.reactivex.WriteStreamObserver;
import io.vertx.reactivex.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 * The kind of the property, this can be used to fetch some specific property of the {@link io.vertx.reactivex.sqlclient.SqlResult execution result}.
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.sqlclient.PropertyKind original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.sqlclient.PropertyKind.class)
public class PropertyKind<T> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    PropertyKind that = (PropertyKind) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<PropertyKind> __TYPE_ARG = new TypeArg<>(    obj -> new PropertyKind((io.vertx.sqlclient.PropertyKind) obj),
    PropertyKind::getDelegate
  );

  private final io.vertx.sqlclient.PropertyKind<T> delegate;
  public final TypeArg<T> __typeArg_0;
  
  public PropertyKind(io.vertx.sqlclient.PropertyKind delegate) {
    this.delegate = delegate;
    this.__typeArg_0 = TypeArg.unknown();  }

  public PropertyKind(Object delegate, TypeArg<T> typeArg_0) {
    this.delegate = (io.vertx.sqlclient.PropertyKind)delegate;
    this.__typeArg_0 = typeArg_0;
  }

  public io.vertx.sqlclient.PropertyKind getDelegate() {
    return delegate;
  }


  /**
   * @param name 
   * @param type 
   * @return a property kind matching the provided <code>name</code>, the <code>type</code> can be used to check the property value type or cast it to the expected type
   */
  public static <T> io.vertx.reactivex.sqlclient.PropertyKind<T> create(String name, java.lang.Class<T> type) { 
    io.vertx.reactivex.sqlclient.PropertyKind<T> ret = io.vertx.reactivex.sqlclient.PropertyKind.newInstance((io.vertx.sqlclient.PropertyKind)io.vertx.sqlclient.PropertyKind.create(name, io.vertx.lang.reactivex.Helper.unwrap(type)), TypeArg.of(type));
    return ret;
  }

  /**
   * @return the property name
   */
  public String name() { 
    String ret = delegate.name();
    return ret;
  }

  public static <T> PropertyKind<T> newInstance(io.vertx.sqlclient.PropertyKind arg) {
    return arg != null ? new PropertyKind<T>(arg) : null;
  }

  public static <T> PropertyKind<T> newInstance(io.vertx.sqlclient.PropertyKind arg, TypeArg<T> __typeArg_T) {
    return arg != null ? new PropertyKind<T>(arg, __typeArg_T) : null;
  }

}
